/*
 *     This file is part of the Action Word Workspace plugin for Squash TM (automation-workspace-actionword) project.
 *     Copyright (C) 2020 - 2023 Henix, henix.fr - All Rights Reserved
 *
 *     Unauthorized copying of this file, via any medium is strictly prohibited
 *     Proprietary and confidential
 *
 * 	 (C)Henix. Tous droits réservés.
 *
 * 	Avertissement : ce programme est protégé par la loi relative au droit d'auteur et par les conventions internationales. Toute reproduction ou distribution partielle ou totale du logiciel, par quelque moyen que ce soit, est strictement interdite.
 */
define(["jquery", "tree", "../permissions-rules", "workspace/workspace.delnode-popup"],
    function ($, zetree, rules) {

        function init() {
            var tree = zetree.get();
            var dialog = $("#delete-action-word-dialog").delnodeDialog({
                tree : tree,
                rules : rules
            });

            dialog.on('delnodedialogconfirm', function(){
                dialog.delnodeDialog('performDeletion');
            });

            dialog.on('delnodedialogcancel', function(){
                $('.delete-node-dialog-details').hide();
                dialog.delnodeDialog('close');
            });

            var $scrollable  = $(".scrollable"),
                $scrollbar   = $(".scrollbar"),
                height       = $scrollable.outerHeight(true),    // visible height
                scrollHeight = $scrollable.prop("scrollHeight"), // total height
                barHeight    = height * height / scrollHeight;   // Scrollbar height!

            // Scrollbar drag:
            $scrollbar.height( barHeight ).draggable({
                axis : "y",
                containment : "associated-test-steps",
                drag: function(e, ui) {
                    $scrollable.scrollTop( scrollHeight / height * ui.position.top  );
                }
            });

            // Element scroll:
            $scrollable.on("scroll", function() {
                $scrollbar.css({top: $scrollable.scrollTop() / height * barHeight });
            });
        }

        return {
            init : init
        };
    });
